/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.00 07 Feb 1996 
 * @author Cay Horstmann
 */

import java.io.*;
import java.util.*;
import corejava.*;

public class DirQueue
{  public static void main(String[] args)
   {  Queue dirs = new Queue();
      dirs.append(new File(File.separator + "."));
      while (dirs.size() > 0)
      {  File f = (File)dirs.remove();
         System.out.println(f);

         String[] s = f.list();
         if (s != null)
         {  for (int i = 0; i < s.length; i++)
            {  File d = new File(f.getAbsolutePath() 
               + File.separator + s[i]);
               if (d.isDirectory())         
                  dirs.append(d);
            }
         }
      }
   }
}

class Queue
{  public void append(Object o) { data.append(o); }
   public Object remove() { return data.remove(); }
   public int size() { return data.size(); }
   public Enumeration elements() { return data.elements(); }
   private LinkedList data = new LinkedList();
}

