/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.10 27 Apr 1997
 * @author Cay Horstmann
 */

import java.awt.*;
import java.awt.event.*;
import corejava.*;

public class CardLayoutTest extends CloseableFrame 
   implements ActionListener
{  public CardLayoutTest()
   {  tabs = new Panel();
      
      addButton("<<");
      addButton("<");
      addButton("Options");
      addButton("Settings");
      addButton("Preferences");
      addButton(">");
      addButton(">>");
      add(tabs, "North");
                  
      cards = new Panel();
      layout = new CardLayout();
      cards.setLayout(layout);
      
      cards.add(new SimpleDialog("Options"), "Options");
      cards.add(new SimpleDialog("Settings"), "Settings");
      cards.add(new SimpleDialog("Preferences"), 
         "Preferences");
      
      add(cards, "Center");
   }

   public void addButton(String name)
   {  Button b = new Button(name);
      b.addActionListener(this);
      tabs.add(b);
   }
   
   public void actionPerformed(ActionEvent evt)
   {  String arg = evt.getActionCommand();
      if (arg.equals("<<")) layout.first(cards);
      else if (arg.equals("<")) layout.previous(cards);
      else if (arg.equals(">")) layout.next(cards);
      else if (arg.equals(">>")) layout.last(cards);
      else layout.show(cards, (String)arg);
   }
   
   public static void main(String[] args)
   {  Frame f = new CardLayoutTest();
      f.setSize(400, 200);
      f.show();  
   }

   private Panel cards;
   private Panel tabs;
   private CardLayout layout;
}

class SimpleDialog extends Panel
{  SimpleDialog(String name)
   {  add(new Label(name + " dialog goes here"));
   }
}
