/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.00 07 Sep 1996 
 * @author Cay Horstmann
 */

import java.rmi.*;
import java.rmi.server.*;

public class WarehouseServer
{  public static void main(String args[])
   {  System.setSecurityManager(new RMISecurityManager());
      try
      {  WarehouseImpl w = new WarehouseImpl();
         fillWarehouse(w);
         Naming.rebind("central_warehouse", w);
      }
      catch(Exception e)
      {  System.out.println("Error: " + e);
      }
   }

   public static void fillWarehouse(WarehouseImpl w)
      throws RemoteException
   {  w.add(new ProductImpl("Blackwell Toaster", 
         Product.BOTH, 18, 200, "Household"));
      w.add(new ProductImpl("ZapXpress Microwave Oven", 
         Product.BOTH, 18, 200, "Household"));
      w.add(new ProductImpl("Jimbo After Shave", 
         Product.MALE, 18, 200, "Beauty"));
      w.add(new ProductImpl("Handy Hand Grenade", 
         Product.MALE, 20, 60, "Gardening"));
      w.add(new ProductImpl("DirtDigger Steam Shovel", 
         Product.MALE, 20, 60, "Gardening"));
      w.add(new ProductImpl("U238 Weed Killer", 
         Product.BOTH, 20, 200, "Gardening"));
      w.add(new ProductImpl("Van Hope Cosmetic Set", 
         Product.FEMALE, 15, 45, "Beauty"));
      w.add(new ProductImpl("Persistent Java Fragrance", 
         Product.FEMALE, 15, 45, "Beauty"));
      w.add(new ProductImpl("Rabid Rodent Computer Mouse", 
         Product.BOTH, 6, 40, "Computers"));
      w.add(new ProductImpl
         ("Learn Bad Java Habits in 21 Days Book", 
         Product.BOTH, 20, 200, "Computers"));
      w.add(new ProductImpl("My first Espresso Maker", 
         Product.FEMALE, 6, 10, "Household"));
      w.add(new ProductImpl("JavaJungle Eau de Cologne", 
         Product.FEMALE, 20, 200, "Beauty"));
      w.add(new ProductImpl("Fast/Wide SCSI Coffee Maker", 
         Product.MALE, 20, 50, "Computers"));
      w.add(new ProductImpl("ClueLess Network Computer", 
         Product.BOTH,6, 200, "Computers"));
   }
}

