/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.10 27 Oct 1997
 * @author Cay Horstmann
 */

import java.beans.*;

public class ChartBeanBeanInfo extends SimpleBeanInfo
{  public PropertyDescriptor[] getPropertyDescriptors()
   {  try
      {  PropertyDescriptor titlePositionDescriptor
            = new PropertyDescriptor("titlePosition",
               ChartBean.class);
         titlePositionDescriptor.setPropertyEditorClass
            (TitlePositionEditor.class);
         PropertyDescriptor inverseDescriptor
            = new PropertyDescriptor("inverse",
               ChartBean.class);
         inverseDescriptor.setPropertyEditorClass
            (InverseEditor.class);
         
         return new PropertyDescriptor[] 
         {  new PropertyDescriptor("title",
               ChartBean.class),
            titlePositionDescriptor,
            new PropertyDescriptor("values",
               ChartBean.class),
            new PropertyDescriptor("graphColor",
               ChartBean.class),
            inverseDescriptor
         };
      }
      catch(IntrospectionException e)
      {  System.out.println("Error: " + e);
         return null;
      }
   }

   static
   {  PropertyEditorManager.registerEditor(double[].class, 
         DoubleArrayEditor.class);
   }
}
